clear all
%close all

% analize how accuracte the F32, Float32full, and FloatMathExtended trig
% functions are.  

%grab the data
data = csvread('FP atan2 sym unstead lfsr.csv');

%sort by angle
sorted = sortrows(data,1);

%split out each collumn
y = sorted(:,1);
x = sorted(:,2);
F32 = sorted(:,3);
F_full = sorted(:,4);
fme = sorted(:,5);

mat = atan2(y,x);

% pretty picture from the LFSR in Spin
figure
plot(x(1:20512),y(1:20512),'k.')



%% calculate statistics


%F32
temp = F32 - mat ;
F32err = temp;
F32min = min(temp)
F32max = max(temp)
F32std = std(temp)


%Float32full
temp = F_full - mat ;
F_fullerr = temp;
F_fullmin = min(temp)
F_fullmax = max(temp)
F_fullstd = std(temp)


%FloatMathExtended
temp = fme - mat ;
fmeerr = temp;
fmemin = min(temp)
fmemax = max(temp)
fmestd = std(temp)





%% pretty pictures
%plot errors
figure
plot(mat, F32err,'b.',mat, F_fullerr, 'g.', mat, fmeerr, 'r.')
grid on
title('Atan2')
legend('F32', 'Float32full','fme')
xlabel('angle [rad]')
ylabel('error')
% 
% figure
% plot(angle, mat.cos, angle, F32.cos, angle, F_full.cos, angle, fme.cos)
% grid on
% title('cosine')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% figure
% 
% plot(angle, mat.tan, angle, F32.tan, angle, F_full.tan, angle, fme.tan)
% grid on
% title('tangent')
% legend('matlab', 'F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('value')
% 
% %plot errors.
% figure
% plot(angle, F32.sinerr, angle, F_full.sinerr, angle, fme.sinerr)
% grid on
% title('sine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.coserr, angle, F_full.coserr, angle, fme.coserr)
% grid on
% title('cosine')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('error')
% 
% figure
% plot(angle, F32.tanerr, angle, F_full.tanerr, angle, fme.tanerr)
% grid on
% title('tangent')
% legend('F32', 'Float32full','fme')
% xlabel('angle [rad]')
% ylabel('relative error')


